// Copyright (C) 2003, 2005 Daisuke Arai <darai@users.sourceforge.jp>
// 
// This program is part of Protra.
//
// Protra is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
// 
// $Id: LogicalTermNode.cs,v 1.4 2007-12-27 08:34:39 panacoran Exp $

using System;
using System.Collections;

namespace Protra.Lib.Lang
{
	/// <summary>
	/// 論理項のノードを表すクラスです。
	/// </summary>
	public class LogicalTermNode : Node
	{
		/// <summary>
		/// ノードのリスト
		/// </summary>
		private ArrayList nodeList = new ArrayList();

		/// <summary>
		/// 文脈を解析します。
		/// </summary>
		/// <exception cref="Protra.Lib.Lang.ParseException">
		/// 文脈にエラーがある場合にthrowされます。
		/// </exception>
		/// <param name="context">コンテキスト</param>
		public override void Parse(Context context)
		{
			this.ContextToken = (ContextToken)context.Current;

			Node node = new EquivalenceComparisonNode();
			node.Parse(context);
			nodeList.Add(node);
			ContextToken ct = (ContextToken)context.Current;
			string token = ct.ToString();
			while(token == "&&")
			{
				context.MoveNext();
				node = new EquivalenceComparisonNode();
				node.Parse(context);
				nodeList.Add(node);
				ct = (ContextToken)context.Current;
				token = ct.ToString();
			}
		}

		/// <summary>
		/// 構文木を簡略化します。
		/// </summary>
		/// <returns>簡略化されたノード</returns>
		public override Node Simplify()
		{
			if(nodeList.Count == 1)
				return ((Node)nodeList[0]).Simplify();
			else
			{
				for(int i = 0; i < nodeList.Count; i++)
				{
					Node node = (Node)nodeList[i];
					nodeList[i] = node.Simplify();
				}
				return this;
			}
		}

		/// <summary>
		/// プログラムを実行します。
		/// </summary>
		/// <exception cref="Protra.Lib.Lang.RuntimeException">
		/// プログラム実行中にエラーが発生した場合にthrowされます。
		/// </exception>
		/// <param name="resource">リソース</param>
		/// <param name="at">@作用素の値</param>
		/// <returns>実行結果</returns>
		public override Value Execute(Resource resource, int at)
		{
			try
			{
				Node node = (Node)nodeList[0];
				Value val1 = node.Execute(resource, at);
				for(int i = 1; i < nodeList.Count; i++)
				{
					if(val1 == null || val1.IsFalse)
						return new Value(false);
					node = (Node)nodeList[i];
					Value val2 = node.Execute(resource, at);
					val1 = val1 & val2;
				}

				return val1;
			}
			catch(RuntimeException exc)
			{
				if (exc.ContextToken == null)
					exc = new RuntimeException(exc.Message, this.ContextToken);
				throw exc;
			}		
		}
	}
}
